//+------------------------------------------------------------------+
//|                                                Ind_Mutly_TRO.mq4 |
//|                                                            Karci |
//|                                                karol_r@inmail.sk |
//+------------------------------------------------------------------+
#property copyright "Karci"
#property link      "karol_r@inmail.sk"

#property indicator_chart_window
//---- input parameters
extern string  Input_H  = "14:00";
extern color   Text           = White;
extern color   Hodnota        = Goldenrod;
extern color   Wait_Text      = Yellow;
extern color   Buy_Text       = Blue;
extern color   Sell_Text      = Red;
extern color   Buy_Text_Ready = Aqua;
extern color   Sell_Text_Ready = LightSalmon;

//------ global variable ----
string Buy_Message  = "TRADE LONG" ;
string Buy_M_Ready = "READY BUY" ;
string Wait_Message = "WAIT" ;
string Sell_Message = "TRADE SHORT" ;
string Sell_M_Ready = "READY SELL" ;
int uvod, Hod, cnt;
double koef;
double H1_open, open_1, close_1, open_2, close_2, open_3, close_3, open_4, close_4;
double open_5, close_5, open_6, close_6, open_7, close_7, DailyOpen;
string M1_Set, M5_Set, M15_Set, M30_Set, H1_Set, H4_Set, D1_Set;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   uvod = 0; Hod = 24;
   koef = 60/Period();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Zobraz_Del();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

//----

   int Cas = StrToInteger(Input_H);
   
   if (Hour() < Cas)
      cnt = (10 + Hour()) * koef;
   else
      cnt = (Hour() - Cas) * koef;
    
   if ((Hour() == Cas && DayOfWeek() != uvod) || DailyOpen == 0)
   {
      DoDailyOpen();
      uvod = DayOfWeek();
   }
   
   open_2 = iOpen(Symbol(),5,0);
   close_2 = iClose(Symbol(),5,0);
   
   open_3 = iOpen(Symbol(),15,0);
   close_3 = iClose(Symbol(),15,0);
   
   open_4 = iOpen(Symbol(),30,0);
   close_4 = iClose(Symbol(),30,0);
    
   open_5 = iOpen(Symbol(),60,0);
   close_5 = iClose(Symbol(),60,0);
   
   open_6 = iOpen(Symbol(),240,0);
   close_6 = iClose(Symbol(),240,0);
   
   open_7 = iOpen(Symbol(),1440,0);
   close_7 = iClose(Symbol(),1440,0);
          
   if (Minute() == 0 && Hour() != Hod)
   {
      H1_open  = iOpen(Symbol(),PERIOD_H1,0);
      Hod = Hour();
   }

//----
   M5_Set = Wait_Message;
   if (close_2 > DailyOpen && close_2 > H1_open)
      if (close_2 > open_2)
         M5_Set = Buy_Message;
      else
         M5_Set = Buy_M_Ready; 
         
   if (close_2 < DailyOpen && close_2 < H1_open)
      if (close_2 < open_2)
         M5_Set = Sell_Message;
      else
         M5_Set = Sell_M_Ready;   
//----
   M15_Set = Wait_Message;
   if (close_3 > DailyOpen && close_3 > H1_open)
      if (close_3 > open_3)
         M15_Set = Buy_Message;
      else
         M15_Set = Buy_M_Ready; 
         
   if (close_3 < DailyOpen && close_3 < H1_open)
      if (close_3 < open_3)
         M15_Set = Sell_Message;
      else
         M15_Set = Sell_M_Ready;
//----
   M30_Set = Wait_Message;
   if (close_4 > DailyOpen && close_4 > H1_open)
      if (close_4 > open_4)
         M30_Set = Buy_Message;
      else
         M30_Set = Buy_M_Ready; 
         
   if (close_4 < DailyOpen && close_4 < H1_open)
      if (close_4 < open_4)
         M30_Set = Sell_Message;
      else
         M30_Set = Sell_M_Ready;
//----
   H1_Set = Wait_Message;
   if (close_5 > DailyOpen && close_5 > H1_open)
      if (close_5 > open_5)
         H1_Set = Buy_Message;
      else
         H1_Set = Buy_M_Ready; 
         
   if (close_5 < DailyOpen && close_5 < H1_open)
      if (close_5 < open_5)
         H1_Set = Sell_Message;
      else
         H1_Set = Sell_M_Ready;
//----
   H4_Set = Wait_Message;
   if (close_6 > DailyOpen && close_6 > H1_open)
      if (close_6 > open_6)
         H4_Set = Buy_Message;
      else
         H4_Set = Buy_M_Ready; 
         
   if (close_6 < DailyOpen && close_6 < H1_open)
      if (close_6 < open_6)
         H4_Set = Sell_Message;
      else
         H4_Set = Sell_M_Ready;
//----
   D1_Set = Wait_Message;
   if (close_7 > DailyOpen && close_7 > H1_open)
      if (close_7 > open_7)
         D1_Set = Buy_Message;
      else
         D1_Set = Buy_M_Ready; 
         
   if (close_7 < DailyOpen && close_7 < H1_open)
      if (close_7 < open_7)
         D1_Set = Sell_Message;
      else
         D1_Set = Sell_M_Ready;         
         
//----
   //Comment("M5  : ", M5_Set,"\nM15 : ",M15_Set,"\nM30 : ",M30_Set,"\nH1  : ",H1_Set);
   Zobraz();
   return(0);
  }
//+------------------------------------------------------------------+

void DoDailyOpen() 
{
   int   yy = TimeYear(Time[0]);
   int   mm = TimeMonth(Time[0]);
   int   dd = TimeDay(Time[0]);  
   
   string yymmddms = yy+"."+mm+"."+dd+" " + Input_H ;
         
   datetime var1 = StrToTime(yymmddms);  
   
   datetime day=24*60*60;
   datetime r= var1 ;

   int      cd=iBarShift(NULL,0,r,FALSE);
   datetime r2=r-day;

   if(TimeDayOfWeek(r2)==0) r2=r2-day-day;
   int cd2=iBarShift(NULL,0,r2,FALSE);

   if( var1 > Time[0] ) { r = r2 ;cd = cd2 ;} // if date/time is greater than current date/time go back 1 day

   DailyOpen = iOpen(Symbol(),0,cd);    
}

//+------------------------------------------------------------------+

void Zobraz()
{
   //Comment(koef,"\n",cnt,"\n",TimeToStr(Time[cnt],TIME_MINUTES),"\n",TimeToStr(Time[0],TIME_MINUTES));
   
   int x_h, y_h, x, y, font, font_h, font_l, roh, pos_h, pos;
   int i = 1;
   font_h = 8; font_l = 14; font = 40; roh = 1;
   x_h = 10; y_h = 20;
   x = 36; y = -8; 
   pos_h = 10; pos = 10;
 
   string Level = DoubleToStr(DailyOpen,Digits);
   string Hodina = DoubleToStr(StrToDouble(Input_H),0);
   
   if (Digits == 2)
      Level = Level + "  ";
   
   ObjectCreate("Level", OBJ_TREND, 0,Time[cnt],DailyOpen,Time[0],DailyOpen);
   ObjectSet("Level",OBJPROP_COLOR,Magenta);
   ObjectSet("Level",OBJPROP_STYLE,STYLE_DASHDOT);
   //ObjectSet("Level",OBJPROP_WIDTH,2);  
    
   LabelCreate("T", x_h-9, y_h-5, font_h, roh, "Cas : " + Input_H, Text);
   LabelCreate("T1", x_h-8, y_h-2, font_h, roh, "_________", Text);
   LabelCreate("L", x_h-8, y_h+pos_h*(i+6)+3, font_l, roh, Level, Hodnota);
      
   LabelCreate("M5H", x_h+6, y_h+pos_h*(i+0), font_h, roh, "M5", Text);
   LabelCreate("M5",  x, y+pos*(i+0), font, roh, "-", Wait_Text); 
   if (M5_Set == Buy_Message)
      LabelCreate("M5",  x, y+pos*(i+0), font, roh, "-", Buy_Text); 
   if (M5_Set == Sell_Message)
      LabelCreate("M5",  x, y+pos*(i+0), font, roh, "-", Sell_Text);
   if (M5_Set == Buy_M_Ready)
      LabelCreate("M5",  x, y+pos*(i+0), font, roh, "-", Buy_Text_Ready); 
   if (M5_Set == Sell_M_Ready)
      LabelCreate("M5",  x, y+pos*(i+0), font, roh, "-", Sell_Text_Ready); 
      
   LabelCreate("M15H", x_h, y_h+pos_h*(i+1), font_h, roh, "M15", Text);
   LabelCreate("M15",  x, y+pos*(i+1), font, roh, "-", Wait_Text); 
   if (M15_Set == Buy_Message)
      LabelCreate("M15",  x, y+pos*(i+1), font, roh, "-", Buy_Text); 
   if (M15_Set == Sell_Message)
      LabelCreate("M15",  x, y+pos*(i+1), font, roh, "-", Sell_Text);
   if (M15_Set == Buy_M_Ready)
      LabelCreate("M15",  x, y+pos*(i+1), font, roh, "-", Buy_Text_Ready); 
   if (M15_Set == Sell_M_Ready)
      LabelCreate("M15",  x, y+pos*(i+1), font, roh, "-", Sell_Text_Ready);

   LabelCreate("M30H", x_h, y_h+pos_h*(i+2), font_h, roh, "M30", Text);
   LabelCreate("M30",  x, y+pos*(i+2), font, roh, "-", Wait_Text); 
   if (M30_Set == Buy_Message)
      LabelCreate("M30",  x, y+pos*(i+2), font, roh, "-", Buy_Text); 
   if (M30_Set == Sell_Message)
      LabelCreate("M30",  x, y+pos*(i+2), font, roh, "-", Sell_Text);
   if (M30_Set == Buy_M_Ready)
      LabelCreate("M30",  x, y+pos*(i+2), font, roh, "-", Buy_Text_Ready); 
   if (M30_Set == Sell_M_Ready)
      LabelCreate("M30",  x, y+pos*(i+2), font, roh, "-", Sell_Text_Ready);

   LabelCreate("H1H", x_h+8, y_h+pos_h*(i+3), font_h, roh, "H1", Text);
   LabelCreate("H1",  x, y+pos*(i+3), font, roh, "-", Wait_Text); 
   if (H1_Set == Buy_Message)
      LabelCreate("H1",  x, y+pos*(i+3), font, roh, "-", Buy_Text); 
   if (H1_Set == Sell_Message)
      LabelCreate("H1",  x, y+pos*(i+3), font, roh, "-", Sell_Text);
   if (H1_Set == Buy_M_Ready)
      LabelCreate("H1",  x, y+pos*(i+3), font, roh, "-", Buy_Text_Ready); 
   if (H1_Set == Sell_M_Ready)
      LabelCreate("H1",  x, y+pos*(i+3), font, roh, "-", Sell_Text_Ready);

   LabelCreate("H4H", x_h+7, y_h+pos_h*(i+4), font_h, roh, "H4", Text);
   LabelCreate("H4",  x, y+pos*(i+4), font, roh, "-", Wait_Text); 
   if (H4_Set == Buy_Message)
      LabelCreate("H4",  x, y+pos*(i+4), font, roh, "-", Buy_Text); 
   if (H4_Set == Sell_Message)
      LabelCreate("H4",  x, y+pos*(i+4), font, roh, "-", Sell_Text);
   if (H4_Set == Buy_M_Ready)
      LabelCreate("H4",  x, y+pos*(i+4), font, roh, "-", Buy_Text_Ready); 
   if (H4_Set == Sell_M_Ready)
      LabelCreate("H4",  x, y+pos*(i+4), font, roh, "-", Sell_Text_Ready);
      
   LabelCreate("D1H", x_h+8, y_h+pos_h*(i+5), font_h, roh, "D1", Text);
   LabelCreate("D1",  x, y+pos*(i+5), font, roh, "-", Wait_Text); 
   if (D1_Set == Buy_Message)
      LabelCreate("D1",  x, y+pos*(i+5), font, roh, "-", Buy_Text); 
   if (D1_Set == Sell_Message)
      LabelCreate("D1",  x, y+pos*(i+5), font, roh, "-", Sell_Text);
   if (D1_Set == Buy_M_Ready)
      LabelCreate("D1",  x, y+pos*(i+5), font, roh, "-", Buy_Text_Ready); 
   if (D1_Set == Sell_M_Ready)
      LabelCreate("D1",  x, y+pos*(i+5), font, roh, "-", Sell_Text_Ready);
      
   return(0);   
}
//--------------------------------------------------------------------   
void LabelCreate(string name,int dist_x,int dist_y,int font_size,int roh = 0,string s_text = "",color farba = 65535) 
{
   int err;
   if (!ObjectCreate(name, OBJ_LABEL, 0, 0, 0)) 
   {
      err = GetLastError();
      if (err != 4200/* OBJECT_ALREADY_EXISTS */) 
         return;
   }
   ObjectSet(name, OBJPROP_CORNER, roh);
   ObjectSet(name, OBJPROP_XDISTANCE, dist_x);
   ObjectSet(name, OBJPROP_YDISTANCE, dist_y);
   ObjectSetText(name, s_text, font_size, "Arial", farba);
}
//+------------------------------------------------------------------+
//|   Zmae zobrazen hodnoty pre Buy a/alebo Sell                   |
//+------------------------------------------------------------------+
double Zobraz_Del()
{   
   ObjectDelete("Level");
   ObjectDelete("T");  ObjectDelete("T1"); 
   ObjectDelete("M5H");  ObjectDelete("M5"); 
   ObjectDelete("M15H");  ObjectDelete("M15");
   ObjectDelete("M30H");  ObjectDelete("M30");
   ObjectDelete("H1H");  ObjectDelete("H1");
   ObjectDelete("H4H");  ObjectDelete("H4");  
   ObjectDelete("D1H");  ObjectDelete("D1");
   return(0);
}

// End      2.3.2010